"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPlainObject = exports.jsonParse = exports.createIncludeNamesTree = void 0;
function createIncludeNamesTree(namesChain, includeTree) {
    const namesArray = namesChain.split('.');
    const currentIncludeName = namesArray.shift();
    const chainHasMoreNames = namesArray.length;
    let subTree = null;
    if (chainHasMoreNames) {
        subTree = includeTree[currentIncludeName] || {};
        createIncludeNamesTree(namesArray.join('.'), subTree);
    }
    includeTree[currentIncludeName] = subTree;
}
exports.createIncludeNamesTree = createIncludeNamesTree;
function jsonParse(stringified) {
    let parsed;
    try {
        parsed = JSON.parse(stringified);
    }
    catch (e) {
        parsed = {};
        console.warn(e);
    }
    return parsed;
}
exports.jsonParse = jsonParse;
// https://github.com/30-seconds/30-seconds-of-code/blob/master/snippets/isPlainObject.md
const isPlainObject = (val) => !!val && typeof val === 'object' && val.constructor === Object;
exports.isPlainObject = isPlainObject;
//# sourceMappingURL=utils.js.map